TRUNCATE(2)

NAME
truncate, ftruncate - truncate or extend a file to a specified length

LIBRARY
libc

SYNOPSIS
#include <unistd.h>
int
truncate(const char *path, off_t length);
int
ftruncate(int fd, off_t length);

DESCRIPTION
Truncate() causes the file named by path or referenced by fd to be truncated or extended to length bytes in size. If the file was larger than this size, the extra data is lost. If the file was smaller than this size, it will be extended as if by writing bytes with the value zero. With ftruncate(), the file must be open for writing.

RETURN VALUES
A value of 0 is returned if the call succeeds. If the call fails a -1 is returned, and the global variable errno specifies the error.

ERRORS
Truncate() succeeds unless:

[ENOTDIR]
    A component of the path prefix is not a directory.

[ENAMETOOLONG]
    A component of a pathname exceeded 255 characters, or an entire path name exceeded 1023 characters.

[ENOENT]
    The named file does not exist.

[EACCES]
    Search permission is denied for a component of the path prefix.

[EACCES]
    The named file is not writable by the user.

[ELOOP]
    Too many symbolic links were encountered in translating the pathname.

[EISDIR]
    The named file is a directory.

[EROFS]
    The named file resides on a read-only file system.

[ETXTBSY]
    The file is a pure procedure (shared text) file that is being executed.

[EIO]
    An I/O error occurred updating the inode.

[EFAULT]
    Path points outside the process's allocated address space.

Ftruncate() succeeds unless:

[EBADF]
    The fd is not a valid descriptor.

[EINVAL]
    The fd references a socket, not a file.

[EINVAL]
    The fd is not open for writing.

SEE ALSO
open(2)

BUGS
These calls should be generalized to allow ranges of bytes in a file to be discarded.

Use of truncate() to extend a file is not portable.

HISTORY
The truncate() function call appeared in 4.2BSD.